=== src/rv/Makefile ===
.phony:
all: ociorv.zip

ociorv.zip:
	mkdir -p Packages
	zip Packages/ociorv.zip Python/ociorv.py Python/PACKAGE
