=== debian/changelog ===
opencolorio (1.1.1~dfsg0-7.1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 17 Jan 2022 12:45:23 +0000

opencolorio (1.1.1~dfsg0-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport parts of upstream commit 2f87cca2e129471f57df0c3a8a3adc0c73a4811c
    to use the proper variables in a debug function (fixing the build with
    GCC 11); patch 0001-Adsk-Contrib-Fix-macos-issues-973.patch.
    (Closes: #984276)
  * Backport parts of upstream commit 7575d9cb0f514a43a4a8b107793914589ae5ac9a
    to support yaml-cpp >= 0.7.0; patch
    0001-Adsk-Contrib-Fix-the-display-order-issue-883.patch
    - bump the libyaml-cpp-dev build dependency to >= 0.6.3 accordingly
  * Add the tex-gyre indep build dependency, as it provides tgtermes.sty
    (needed to build the documentation).

 -- Pino Toscano <pino@debian.org>  Fri, 24 Dec 2021 11:33:28 +0100

opencolorio (1.1.1~dfsg0-7) unstable; urgency=medium

  * debian/control:
    - debhelper bump 12 -> 13
    - S-V bump 4.5.0 -> 4.5.1 (no changes needed)
    - missing build-dep libopenexr-dev added (Closes: #976566)
  * debian/watch: version bump 3 -> 4
  * debian/rules: drop useless script
  * debian/libopencolorio-dev.install: install cmake helpers

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 17 Dec 2020 23:58:56 +0100

opencolorio (1.1.1~dfsg0-6) unstable; urgency=medium

  * debian/python3-pyopencolorio.install: drop version-specific
    python path (Closes: #949917)
  * debian/control: S-V bump 4.4.1 -> 4.5.0 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 27 Feb 2020 09:51:52 +0100

opencolorio (1.1.1~dfsg0-5) unstable; urgency=medium

  * debian/rules: pyclean -> py3clean

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 07 Dec 2019 14:31:30 +0100

opencolorio (1.1.1~dfsg0-4) unstable; urgency=medium

  * debian/: py2 -> py3 migration (Closes: #937196)
  * debian/compat: dropped due to debhelper 12
  * debian/control: S-V bump 4.4.0 -> 4.4.1 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 05 Dec 2019 17:39:54 +0100

opencolorio (1.1.1~dfsg0-3) unstable; urgency=medium

  * debian/control:
    - S-V bump 4.3.0 -> 4.4.0 (no changes needed)
    - switch to texlive-plain-generic as b-dep (Closes: #933289)

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 05 Aug 2019 22:52:38 +0200

opencolorio (1.1.1~dfsg0-2) unstable; urgency=medium

  * Upload to unstable

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 08 Jul 2019 15:16:46 +0200

opencolorio (1.1.1~dfsg0-1) experimental; urgency=medium

  * New upstream release
    - debian/patches/: patchset updated
  * debian/: repacking method improved

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 09 Apr 2019 23:26:50 +0200
