=== debian/watch ===
version=4
opts="dversionmangle=s/\~dfsg.*//, \
repack, \
repacksuffix=~dfsg0" \
https://github.com/imageworks/OpenColorIO/tags .*/v(\d.*)\.(?:tgz|tar\.(?:gz|bz2|xz))
